#include "grafi.h"



int* compfortconn(list_Ptr *G, int n_nodi, int nodo) 
{
visitati *visG=calloc(n_nodi+1,sizeof(visitati)); /* vettore dei visitati di G*/
visitati *visT=calloc(n_nodi+1,sizeof(visitati)); /* vettore dei visitati di T==G^t */
list_Ptr *T;
int n=0,i=1,j,k,*comp=calloc((n_nodi+1)*(n_nodi+1),sizeof(int));
	
	/* calcolo G^t==T */
	T=ordina_lista(G,n_nodi);

	while(1) {
	
		/* inizializzo i vettori dei visitati */
		for(k=0;k<=n_nodi;k++) {
			visG[k].invis=visG[k].finvis=0;
			visT[k].invis=visT[k].finvis=0;
		}

		/* faccio la DFS su G */
		k=1;
		DFS_INFIN(G,nodo,n_nodi,visG,&k);
	
		/* faccio la DFS su T */
		k=1;
		DFS_INFIN(T,nodo,n_nodi,visT,&k);

		/* resetto il nodo su cui fare la visita */
		nodo=0;

		/* inserisco nella matrice gli elementi visitati 
		 * in entrambe le visite e decido quale sara'
		 * il prossimo elemento da cui cominciare la visita
		 */
		for(j=1;j<=n_nodi;j++) {
			if(visG[j].invis && visT[j].invis) {
				comp[(i*n_nodi)+j]=j;
				n++;
			}

			else {
				if(nodo) {
					if(visG[nodo].finvis<visG[j].finvis)
						nodo=j;
				}

				else {
					nodo=j;
				}
			}
		}

		if(n>=n_nodi) break;
		i++;
	}

	return comp;
}

list_Ptr* Gq(list_Ptr *G, int n_nodi) 
{
int i;
list_Ptr* Gq=calloc(n_nodi+1,sizeof(list_Ptr));
list_Ptr ptr,ptr2;

	for(i=1;i<=n_nodi;i++) {
		for(ptr=G[i];ptr;ptr=ptr->next) {
			Gq[i]=addHead(Gq[i],ptr->val);
			for(ptr2=G[ptr->val];ptr2;ptr2=ptr2->next) 
				if(ptr2->val!=i)
					Gq[i]=addHead(Gq[i],ptr2->val);
		}
	}

	/* cancello i doppioni */
	Gq=ordina_lista(Gq,n_nodi);
	for(i=0;i<n_nodi;i++) {
		ptr=Gq[i];
		while(ptr) {
			ptr2=ptr->next;
			while(ptr2 && ptr->val == ptr2->val) {
				ptr->next=ptr2->next;
				free(ptr2);
				ptr2=ptr->next;
			}

			ptr=ptr->next;
		}
	}

	return Gq;
}

void DFS(list_Ptr *L, int nodo, int n_nodi, int *vis)
{
stack_Ptr S=NULL;
list_Ptr pointer;

	printf("sto visitando %d\n",nodo);
	vis[nodo]=1;
	
	if(L[nodo])
		S=push(S,L[nodo]);
	
	while((pointer=pop(&S)))
	{
		if(pointer->next)
			S=push(S,pointer->next);
		if(vis[pointer->val]==0)
		{
			printf("sto visitando %d\n",pointer->val);
			vis[pointer->val]=1;
			pointer=L[pointer->val];
			while(pointer && vis[pointer->val])
				pointer=pointer->next;
			if(pointer)
				S=push(S,pointer);
		}
	}
}

void DFS_INFIN(list_Ptr *L, int nodo, int n_nodi, visitati *VIS, int *i)
{
list_Ptr temp;

	VIS[nodo].invis=*i;
	printf("sto visitando %d\n",nodo);
	for(temp=L[nodo];temp;temp=temp->next) {
		if(!VIS[temp->val].invis) {
			*i+=1;
			DFS_INFIN(L,temp->val,n_nodi,VIS,i);
		}
	}	
	*i+=1;
	VIS[nodo].finvis=*i;
}

void DFS_INFIN_ELIM(list_Ptr *L, int nodo, int n_nodi, visitati *VIS, int *i)
{
list_Ptr temp;

	VIS[nodo].invis=*i;
	printf("sto visitando %d\n",nodo);
	while(L[nodo]) {
		if(!VIS[L[nodo]->val].invis) {
			*i+=1;
			DFS_INFIN_ELIM(L,L[nodo]->val,n_nodi,VIS,i);
		}
		temp=L[nodo];
		L[nodo]=L[nodo]->next;
		free(temp);
	}
	*i+=1;
	VIS[nodo].finvis=*i;

}

void DFS2(list_Ptr *L, int nodo, int n_nodi, visitati *vis)
{
/* mo lascio perdere, comunque il problema e' che non riesco a controllare il fatto che 
 * se non inserisco nella coda un nodo [ if(pointer->next) S=push(S,pointer->next) ] 
 * adiacente perche' questo effettivamente non c'e', allora, una volta finita la visita del nodo
 * che invece ho appena tirato fuori, il vettore dei visitati dovrebbe mettere un fine visita
 * alla posizione i corrente della lista di adiacenza
 * bella inculata :P
 */
int i=1,aux;
stack_Ptr S=NULL;
list_Ptr pointer;

	printf("sto visitando %d\n",nodo);
	vis[nodo].invis=1;
	
	if(L[nodo])
		S=push(S,L[nodo]);
	
	while((pointer=pop(&S)))
	{
		if(pointer->next)
			S=push(S,pointer->next);
		
		if(vis[pointer->val].invis==0)
		{
			printf("sto visitando %d\n",pointer->val);
			vis[pointer->val].invis=++i;
			aux=pointer->val;
			pointer=L[pointer->val];
			while(pointer && vis[pointer->val].invis)
				pointer=pointer->next;
			if(pointer)
				S=push(S,pointer);
			else
				vis[aux].finvis=++i;
				
		}
	}
}

void BFS(list_Ptr *L, int nodo, int n_nodi, int *vis)
{
coda_Ptr C;
list_Ptr pointer;
	
	create_queue(&C);

	printf("sto visitando %d\n",nodo);
	vis[nodo]=1;
	C=enqueue(C,nodo);
	
	while((nodo=dequeue(&C))!=0)
	{
		for(pointer=L[nodo];pointer;pointer=pointer->next)
			if((!vis[pointer->val]))
			{
				printf("sto visitando %d\n",pointer->val);
				vis[pointer->val]=1;
				C=enqueue(C,pointer->val);
			}
	}

}

list_Ptr *costruisci(list_Ptr *L, int n_nodi)
{
int i,k;

	printf("costruisco un grafo con %d elementi\n",n_nodi);

	L=calloc(n_nodi+1,sizeof(list_Ptr)); 

	for(i=1;i<=n_nodi;i++) 
	{
		printf("sono al nodo %d\n",i);
		printf("(0 per skippare, numero per aggiungere) : ");
		scanf("%d",&k);

		while(k)
		{
			printf("(0 per skippare, numero per aggiungere) : ");
			L[i]=addHead(L[i],k);
			scanf("%d",&k);
		}
	}

	return L;
}	


int compConn(list_Ptr *L, int nodo, int n_nodi)
{
int *vis,i,n_comp=1;

	vis=calloc(n_nodi+1,sizeof(int));

	vis[nodo]=1;

	if((L[nodo]!=NULL))
	{
		BFS(L,nodo,n_nodi,vis);
		for(i=1;i<=n_nodi;i++)
		{
			if(vis[i]==0)
			{
				n_comp++;
				BFS(L,i,n_nodi,vis);
			}
		}
	}

	return n_comp;
}
			
list_Ptr* ordina_lista(list_Ptr *L, int n_nodi)
{
int i;
list_Ptr *new,pointer;

	if(L) {

		new=calloc(n_nodi+1,sizeof(list_Ptr));

		for(i=n_nodi;i>=1;i--)
			for(pointer=L[i];pointer;pointer=pointer->next)
				new[pointer->val]=addHead(new[pointer->val],i);
	
		return new;
	}

	else
		return NULL;	
	
}
	
int *calcola_ordine(list_Ptr *L, int n_nodi)
{
int i,*vett;
list_Ptr pointer;

	vett=calloc(n_nodi+1,sizeof(int));

	for(i=1;i<=n_nodi;i++)
		for(pointer=L[i];pointer;pointer=pointer->next)
			vett[i]=vett[i]+1;

	return vett;
}
		

list_Ptr rel_ordine(list_Ptr *L, int n_nodi)
{
int *ordine,i,popped;
list_Ptr *T,ret=NULL,temp;
stack_PtrInt S=NULL;

	T=ordina_lista(L,n_nodi);
	ordine=calcola_ordine(T,n_nodi);

	/* inserisco le sorgenti in una pila */
	for(i=1;i<=n_nodi;i++)
		if(ordine[i]==0)
			S=pushInt(S,i);
	
	while((popped=popInt(&S)))
	{
		ret=addHead(ret,popped);
		
		for(temp=L[popped];temp;temp=temp->next)
		{
			ordine[temp->val]=ordine[temp->val]-1;
			if(ordine[temp->val]==0)
				S=pushInt(S,temp->val);
		}
	}

	return ret;
}


int* PruferOLD(list_Ptr *G, int n_nodi)
{
// le linee di codice marcate con "//" sono  di controllo. non dovrebbero mai essere eseguite se tutto va bene
// (o almeno credo....lol)

int *codice,*grado,*visitati,i,c=1; // con i scorro gli indici del grafo, con c gli indici del codice
int flag=0; // flag che serve a tenere in mente la posizione di un eventuale elemento il cui grado e' stato
            // decrementato fino a 1 per confrontarlo con la prossima foglia e decidere quale attaccare al codice
list_Ptr temp_ptr=NULL;

	codice=calloc(n_nodi,sizeof(int)); // 1 piu' piccolo di n_nodi
	visitati=calloc(n_nodi+1,sizeof(int));
	
	grado=calcola_ordine(G,n_nodi);
	// invece di controllare quelli con lo 0 controllo quelli 
	// con l'1 perche' la "calcola_ordine" torna il grado che e' di 1
	// maggiore del valore del codice di Prufer

	for(i=1;i<=n_nodi;i++)
	{
		if(grado[i]==1)
		{
			if((flag!=0) && (flag<i))
			{
				i--;
				visitati[flag]=1;
				temp_ptr=G[flag];
				while((temp_ptr) && (visitati[temp_ptr->val]==1))
					temp_ptr=temp_ptr->next;
				
				if(temp_ptr)
				{
					if(--grado[temp_ptr->val]==1)
						flag=temp_ptr->val;
					else
						flag=0;

					codice[c]=temp_ptr->val;
					if(++c>n_nodi) //
						break;
				}

				else //
				{
					printf("qualcosa e' andato storto\n");
					exit(-1);
				}
			}
			
			else
			{
				visitati[i]=1;
				codice[c]=G[i]->val;
				if(++c>n_nodi) //
					break;
				grado[G[i]->val]--;
				if(((grado[G[i]->val])==1))
					flag=G[i]->val;
			}
		}
	}

	return codice;
}

list_Ptr* De_PruferOLD(int *codice, int n_nodi)
{
list_Ptr *G=NULL; // grafo da tornare
int *gradi=NULL; // array su cui metto i gradi di apparizione nel codice
int pr=1; // con questo indice mi scorro il codice 
int i; // con questo mi scorro l'array dei gradi 
int flag=0; // flag che serve a tenere in mente la posizione di un eventuale elemento il cui grado e' stato
            // decrementato fino a 1 per confrontarlo con la prossima foglia e decidere quale attaccare al grafo

	G=calloc(n_nodi+1,sizeof(list_Ptr)); // creo il grafo
	
	gradi=calloc(n_nodi+1,sizeof(int));
	
	// ora calcolo i gradi di apparizione nel codice
	// il for finisce a <= n_nodi-1 perche' il codice contiene n_nodi -1 informazioni
	// (giusto anche per come glielo passo..)
	for(i=1;i<=(n_nodi-1);i++)
		gradi[codice[i]]++;
	
	// ora scorro i gradi
	for(i=1;i<=n_nodi;i++)
	{
		if(gradi[i]==0)
		{
			if(flag>0 && flag<i)
			{
				i--;
				G[codice[pr]]=addHead(G[codice[pr]],flag);
				gradi[codice[pr]]--;
				if(gradi[codice[pr]]==0)
					flag=codice[pr];
				else
					flag=0;
				pr++;
			}
			
			else
			{
				G[codice[pr]]=addHead(G[codice[pr]],i);
				gradi[codice[pr]]--;
				if(gradi[codice[pr]]==0)
					flag=codice[pr];
				pr++;
			}
		}
	}

	// per gli ultimi elementi..
	if(flag!=0)
	{
		while(pr<=n_nodi)
		{
			G[codice[pr]]=addHead(G[codice[pr]],flag);
			flag=codice[pr];
			pr++;
		}
	}

	return G;
}

int* Prufer(list_Ptr *G, int n_nodi)
{
int i,v,x,j=1,*grado,*C=calloc(n_nodi+1,sizeof(int)),*vis=calloc(n_nodi+1,sizeof(int));
list_Ptr ptr;

	grado=calcola_ordine(G,n_nodi);

	for(i=1;i<=n_nodi-1;i++) {
		v=i;
		while(grado[v]==1) {
			ptr=G[v];
			while(vis[ptr->val]==1) // cerco l'ultimo elemento libero nella lista di adiacenza del
				ptr=ptr->next;  // nodo il cui grado e' 1
			
			C[j++]=ptr->val; // inserisco nel codice l'elemento al quale era attaccato
			vis[v]=1; // marco il nodo appena inserito come visitato
			x=ptr->val; // prendo il nome dell'elemento a cui era attaccato
			if(--grado[x]==1 && x<i) // se diminuendo il grado dell'elemento a cui era attaccato
						 // questo va a 1 e il suo indice e' minore di i allora devo
						 // operare su di lui.
				v=x;
			else			 // altrimenti faccio continuare il for..
				break;
		}
	}

	return C;
}


int* De_Prufer(int *C, int n_nodi)
{
int j=1,i,v,x, 
    n=n_nodi+1, // numero di nodi del vettore S 
    *occ=calloc(n+1,sizeof(int)), // vettore che contiene il grado degli elementi del codice
				    // (n+1 perche' mi servono tutti i nodi e perche' voglio partire da 1
    *S=calloc(n,sizeof(int)); // il vettore di ritorno deve contenere n-1 elementi, quindi alloco n per partire da 1							   

	C[n_nodi]=n;

	// calcolo il numero di occorrenze 
	for(i=1;i<=n_nodi;i++)
		occ[C[i]]+=1;
	

	for(i=1;i<n_nodi;i++) {
		v=i;
		while(occ[v]==0) {
			x=j++; // prendo la posizione corrente nel vettore S e aumento l'indice j
			S[x]=v; // scrivo in S alla posizione corrente il nodo foglia trovato (con occ[v]==0)
			--occ[C[x]]; // diminuisco il numero di occorrenze dell'elemento x al quale era attaccato v
			if(occ[x]==0 && x<i)
				v=x;
			else
				break;
		}
	}

	return S;
}
			
		


/* ALGORITMI DI KRUSKAL E PRIM */


list_Ptr addHead_pes(list_Ptr L, int elem, int cost)
// serve nell'algoritmo di Prim per ritornare il MST n-ario
// o comunque per costruire grafi pesati
{
list_Ptr New=malloc(sizeof(list_Ptr));

	New->next=L;
	New->val=elem;
	New->cost=cost;

	return New;
}

int find_min_prim(visitati_prim *V, int n_elem)
{
int min=INT_MAX,i,ret_i;

	for(i=1;i<=n_elem;i++)
		if(min>V[i].costo && V[i].visitato==0) 
		// se il costo e' minore di quello considerato precedentemente..
		// NOTA! faccio un controllo per evitare di considerare nodi
		// gia' visitati in modo da non creare cicli
		{
			min=V[i].costo; // indico il nuovo minimo
			ret_i=i; // mi salvo il suo indice

		}

	return ret_i; // torno l'indice dell'ultimo minimo trovato
}

list_Ptr *costruisci_pes(list_Ptr *L, int n_nodi)
{
int i,k,pes;

	printf("costruisco un grafo pesato di %d elementi\n",n_nodi);

	L=calloc(n_nodi+1,sizeof(list_Ptr)); 

	for(i=1;i<=n_nodi;i++) 
	{
		printf("sono al nodo %d\n",i);
		printf("(0 per skippare, numero per aggiungere)\n(inserire nodo e peso) : ");
		scanf("%d %d",&k,&pes);

		while(k)
		{
			L[i]=addHead_pes(L[i],k,pes);
			printf("(0 per skippare, numero per aggiungere)\n(inserire nodo e peso) : ");
			scanf("%d %d",&k,&pes);
		}
	}

	return L;
}	


// PRIM (versione O(n^2) con n = numero dei nodi del grafo (non orientato eh)
list_Ptr* Prim_n2(list_Ptr *G, int n_nodi, int nodo_iniziale)
{
// assumo che il grafo sia completamente connesso e non orientato

visitati_prim V[n_nodi+1]; // struttura speciale per i visitati
int i,n_visitati=0,min;
list_Ptr *L_ret=NULL,temp;

	/* inizializzazioni */
	L_ret=calloc(n_nodi+1,sizeof(list_Ptr)); // inizializzo la lista di adiacenza che devo tornare
	
	for(i=1;i<=n_nodi;i++) // resetto il vettore dei visitati
	{
		V[i].radice=V[i].visitato=0;
		V[i].costo=INT_MAX;
	}

	/* il caso del primo elemento */
	temp=G[nodo_iniziale];

	V[nodo_iniziale].visitato=1; // lo metto come visitato
	while(temp)
	// inserisco i valori della lista di adiacenza del primo nodo
	// (non faccio controlli perche' tanto e' il primo nodo e non serve)
	{
		V[temp->val].costo=temp->cost;
		V[temp->val].radice=nodo_iniziale;
		temp=temp->next;
	}
	n_visitati++; // aumento di uno il contatore dei visitati

	
	/* gli altri nodi */
	while(n_visitati<n_nodi) // finche' nn li ho visitati tutti
	{
		min=find_min_prim(V,n_nodi); // cerco il minimo
		n_visitati++; // aumento il contatore dei visitati
		L_ret[V[min].radice]=addHead_pes(L_ret[V[min].radice],min,V[min].costo); // inserisco il nodo nell'albero n_ario
		       								         // che ritorno
											 
		V[min].visitato=1; // lo setto come visitato perche' sto per visitare la sua lista di adiacenza
		
		temp=G[min]; // mi sposto sulla sua lista di adiacenza

		while(temp) // scorro la lista di adiacenza inserendo i vari valori che trovo
		{
			if(V[temp->val].visitato==0 && V[temp->val].costo>temp->cost)
			// se non l'ho gia' visitato e se il suo costo e' minore di quello che c'e' gia'..
			{
				V[temp->val].costo=temp->cost; // aggiorno il costo..
				V[temp->val].radice=min; // ..e il radice
			}
			
			temp=temp->next; // passo al prossimo elemento
		}
	}

	return L_ret;
}


// FUNZIONI DI GESTIONE HEAP_PRIM MINIMO
void heapify_min_prim(int *heap, int in, int fin, int *costo)
{
int j,i=in,temp;


	while((2*i)<fin)
	{
		if(costo[heap[(2*i)]]<costo[heap[((2*i)+1)]]) // scelgo il minore tra i figli
			j=2*i;
		else
			j=(2*i)+1;
			
		if(costo[heap[i]]>costo[heap[j]]) // se la radice e' maggiore la scambio e riparto dalla radice spostata
		{
			temp=heap[i];
			heap[i]=heap[j];
			heap[j]=temp;

			i=j;
		}

		else		// altrimenti la radice e' al posto giusto quindi esco
			break;
	}

	if(2*i==fin) // se sono uscito perche' 2*i e' uguale a fin, faccio un controllo su quest'ultimo elemento prima di uscire
	{
		if(costo[heap[i]]>costo[heap[2*i]])
		{
			temp=heap[i];
			heap[i]=heap[2*i];
			heap[2*i]=temp;
		}
	}

	return;
}
	
void insheap_min_prim(int *H, int i, int *costo)
{
int temp;

	while((i/2) && (costo[H[i/2]]>costo[H[i]])) {
		temp=H[i];
		H[i]=H[i/2];
		H[i/2]=temp;
		i=i/2;
	}
}

int extractheap_min_prim(int *H, int n_elem, int *costo) 
{
int ret;
	
	ret=H[1];
	H[1]=H[n_elem];
	heapify_min_prim(H,1,n_elem,costo);

	return ret;
}
		
list_Ptr* Prim_mlogm(list_Ptr *G, int n_nodi, int nodo_iniziale)
{
// MAI TESTATO
// presumo che il grafo sia completamente connesso e non orientato
int min,i,contatore=0,n_visitati=0; // variabili e contatori vari
int H[n_nodi+1],visitato[n_nodi+1],costo[n_nodi+1],padre[n_nodi+1]; // strutture per la gestione dell'heap e dei costi
list_Ptr aux,*Ret;
	
	// inizializzazioni 
	for(i=1;i<=n_nodi;i++) {
		H[i]=0;
		visitato[i]=0;
		padre[i]=0;
		costo[i]=INT_MAX;
	}
	Ret=calloc(n_nodi+1,sizeof(list_Ptr)); // albero di ritorno
	
	/* il caso del primo elemento */
	visitato[nodo_iniziale]=1; // lo marco come visitato
	for(aux=G[nodo_iniziale];aux;aux=aux->next) { // scorro la lista di adiacenza del nodo iniziale
		contatore++; // aumento il contatore per spostarmi nel vettore heap
		padre[aux->val]=nodo_iniziale; // setto il padre dell'elemento corrente
		costo[aux->val]=aux->cost; // inserisco il costo del collegamento
		H[contatore]=aux->val; // aggiungo l'elemento all'heap
		insheap_min_prim(H,contatore,costo); // inserisco nell'heap in modo ordinato (logm)
	}
	n_visitati++; // aumento il contatore dei visitati

	/* gli altri nodi */
	while(n_visitati<n_nodi) // finche' nn li ho visitati tutti
	{
		min=extractheap_min_prim(H,contatore,costo); // cerco il minimo
		Ret[padre[min]]=addHead_pes(Ret[padre[min]],min,costo[min]); // inserisco il nodo nell'albero n_ario
			
		visitato[min]=1; // setto come visitato l'elemento di cui sto per scorrere la lista di adiacenza
		n_visitati++; // aumento il contatore dei visitati
		
		// scorro la sua lista di adiacenza
		for(aux=G[min];aux;aux=aux->next) {
			if(visitato[aux->val]==0 && (aux->cost)<(costo[aux->val]))
			// se non l'ho gia' visitato e se il suo costo e' minore di quello che c'e' gia'..
			{
				contatore++; // aumento il contatore per spostarmi nel vettore heap
				padre[aux->val]=min; // aggiorno il padre	
				costo[aux->val]=aux->cost;// aggiorno il costo
				H[contatore]=aux->val; // aggiungo l'elemento all'heap
				insheap_min_prim(H,contatore,costo); // inserisco nell'heap in modo ordinato (logm)
			}
		}
	}

	return Ret;
}	
	

// KRUSKAL 

// NOTA! presumo che la lista degli spigoli sia gia' ordinata con una qualsiasi
// funzione di ordinamento del tipo O(nlog(n))
spigoli* crea_lista_spigoli(int *n)
{
int i,k;
spigoli *s;

	printf("quanti spigoli? : ");
	scanf("%d",n);
	s=calloc((*n)+1,sizeof(spigoli));

	for(i=1;i<=*n;i++)
	{
		printf("spigolo %d\n\tinserire vertice1: ",i);
		scanf("%d",&k);
		s[i].vertice1=k;
		printf("\tinserire vertice2: ");
		scanf("%d",&k);
		s[i].vertice2=k;
		printf("\tinserire costo: ");
		scanf("%d",&k);
		s[i].costo=k;
	}

	return s;
}

int cerca_radice(kruskal *K, int elem)
{
	while(elem!=K[elem].radice)
		elem=K[elem].radice;

	return elem;
}
	

list_Ptr* Kruskal(spigoli *S, int n_elem, int n_spigoli)
{
// presumo, come al solito, che il grafo sia completamente connesso e non orientato
int i,rango_maggiore=1; // rango_maggiore serve a fermare tutto non appena un albero non include tutti gli elementi
kruskal K[n_elem+1]; // struttura base
list_Ptr *L; // lista di adiacenza che torno
int radice1,radice2,radice_maggiore,radice_minore,vertice_maggiore,vertice_minore; 
// indici con i quali mi sposto nella struttura kruskal
	
	// inizializzo la lista di adiacenza da tornare
	L=calloc(n_elem+1,sizeof(list_Ptr));

	for(i=1;i<=n_elem;i++) // resetto la struttura principale
	{
		K[i].radice=i;
		K[i].rango=1;
	}
	       	
	i=1; // lo metto ad 1 per iniziare a scorrere la lista degli spigoli
	while(rango_maggiore<n_elem && i<=n_spigoli ) // ciclo principale
	{
		radice1=cerca_radice(K,S[i].vertice1); // cerco i padri dei due elementi dello spigolo  	
		radice2=cerca_radice(K,S[i].vertice2); // che sto prendendo in considerazione

		if(radice1!=radice2) // se le radici sono diverse (evito di costruire cicli)
		{
			// con questo if()..else() mi segno l'albero maggiore e quello minore
			if(K[radice1].rango>=K[radice2].rango) 
			{
				radice_maggiore=radice1;
				radice_minore=radice2;
				vertice_maggiore=S[i].vertice1;
				vertice_minore=S[i].vertice2;
			}

			else
			{
				radice_maggiore=radice2;
				radice_minore=radice1;
				vertice_maggiore=S[i].vertice2;
				vertice_minore=S[i].vertice1;
			}

			K[radice_maggiore].rango+=K[radice_minore].rango; // aggiungo al rango del maggiore quello del minore
			if(rango_maggiore<K[radice_maggiore].rango) // se l'ultimo albero aggiornato e' il piu' grande me lo segno
				rango_maggiore=K[radice_maggiore].rango;

			// ora setto la radice dell'albero minore (va all'elemento che all'inizio faceva
			// parte dell'albero maggiore) come nodo dell'albero maggiore
			K[radice_minore].radice=vertice_maggiore;

			L[vertice_maggiore]=addHead_pes(L[vertice_maggiore],vertice_minore,S[i].costo);
		}
		
		i++;
	}


	for(i=1;i<=n_elem;i++) // stampo la struttura principale
		printf("elemento %d\n\tradice: %d\n\trango: %d\n",i,K[i].radice,K[i].rango);


	return L;
}
	
