#ifndef TREE_H
#define TREE_H

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "coda.h"

typedef struct TREENODE {
	struct TREENODE *left;
	struct TREENODE *right;
	void *item;
	int hsx;
	int hdx;
} Tnode;
typedef Tnode *Tnode_Ptr;

typedef struct N_TREENODE {
	struct N_TREENODE *figlio;
	struct N_TREENODE *fratello;
	void *item;
} n_tree;
typedef n_tree *n_tree_ptr;

/* alberi binari */
void printH(Tnode_Ptr T, int h);
// al primo passaggio h==0;
Tnode_Ptr chooseInsert(Tnode_Ptr T, void *elem);
void levelVisit(Tnode_Ptr T);
void create_Tree(Tnode_Ptr *T);

// alberi binari funzioni di rotate
void left_rotate(Tnode_Ptr *T, Tnode_Ptr *P);
void right_rotate(Tnode_Ptr *T, Tnode_Ptr *P);
void left_left(Tnode_Ptr *T, Tnode_Ptr *P);
void left_right(Tnode_Ptr *T, Tnode_Ptr *P);
void right_left(Tnode_Ptr *T, Tnode_Ptr *P);
void right_right(Tnode_Ptr *T, Tnode_Ptr *P);
void bil_cycle(void);
int insert_bil(Tnode_Ptr *T, Tnode_Ptr *P, int elem);
void print_bil(Tnode_Ptr T, int h);
int max(int a, int b);

/* alberi n_ari */
void print_n(n_tree_ptr T, int h);
// al primo passaggio h==0;
n_tree_ptr chooseInsert_n(n_tree_ptr T, void *elem);
void create_Tree_n(n_tree_ptr *T);

// da nari a bin e viceversa
Tnode_Ptr n_to_bin(n_tree_ptr N, Tnode_Ptr B);
n_tree_ptr bin_to_n(Tnode_Ptr B, n_tree_ptr N);

/* Heap */
int* tree_to_vet(Tnode_Ptr T, int n_elem);
Tnode_Ptr heap_to_tree(int *heap, int in, int fin);
// heap massimo
void heapify(int *heap, int in, int fin);
void HeapSort(int *heap, int in, int fin);
void make_heap(int *heap, int fin);
void elimina_da_heap(int *heap, int fin, int elem);
// heap minimo
void heapify_min(int *heap, int in, int fin);
void HeapSort_min(int *heap, int in, int fin);
void make_heap_min(int *heap, int fin);
void elimina_da_heap_min(int *heap, int fin, int elem);

n_tree_ptr ad_to_n(list_Ptr *G, n_tree_ptr T, int elem, list_Ptr L);
Tnode_Ptr ad_to_bin(list_Ptr *G, Tnode_Ptr T, int elem, list_Ptr L);

#endif

