/* MARCO VALERIO BARBERA */

#include "lib/grafi.h"

int main(void)
{
int n_nodi,elem;
list_Ptr *G;
n_tree_ptr T=NULL;

	printf("quanti nodi ? : ");
	scanf("%d",&n_nodi);
	G=costruisci(G,n_nodi); /* funzione definita in "grafi.h" che tramite
	                           input costruisce una lista di adiacenza */

	printf("la lista creata e'\n");
	printList(G,n_nodi); /* funzione definita in "grafi.h" 
                            che stampa la lista di adiacenza */

	printf("qual'e' la radice? :");
	scanf("%d",&elem); /* prendo in input il nodo su cui radicare 
                          l'albero n-ario */
	
	B=ad_to_bin(G,B,elem,NULL); /* chiamo la funzione di conversione da n_ario
				                  (rappresentato tramite lista di adiacenza)
				                   a binario */
	
	printH(B,0); // stampo l'albero binario creato		
	
	return 0;
}


/* ..nel file grafi.h */

typedef struct TREENODE {
	struct TREENODE *left;
	struct TREENODE *right;
	void *item;
} Tnode;
typedef Tnode *Tnode_Ptr;

n_tree_ptr ad_to_n(list_Ptr *G, n_tree_ptr T, int elem, list_Ptr L);
Tnode_Ptr ad_to_bin(list_Ptr *G, Tnode_Ptr T, int elem, list_Ptr L);


/* ..nel file grafi.c */

Tnode_Ptr ad_to_bin(list_Ptr *G, Tnode_Ptr T, int elem, list_Ptr L)
// la prima chiamata deve essere fatta con L==NULL
{
	T=malloc(sizeof(Tnode)); // creo il nodo
	T->item=(int*)elem;
	T->left=NULL;
	T->right=NULL;

	if(G[elem]) // se G[elem] ha qualche adiacente..
		T->left=ad_to_bin(G,T->left,G[elem]->val,G[elem]->next);
	    /* attacco come figlio sinistro il primo elemento della lista 
           di adiacenza e passo G[elem]->next (che e' il secondo elemento della 
           lista di adiacenza) come lista di fratelli */
	
	if(L) // "L" e' la lista dei fratelli che dovro' attaccare come figli destri
		T->right=ad_to_bin(G,T->right,L->val,L->next);

	return T; // ritorno l'albero creato fino ad ora
}


/* esempio di esecuzione... */

la lista creata e'
 1|->2->3->4->5->NULL
 2|->NULL
 3|->NULL
 4|->NULL
 5|->NULL
 6|->7->1->9->NULL
 7|->NULL
 8|->6->NULL
 9|->NULL
10|->8->NULL

qual'e' la radice? :10

10
        8
                6
                                        9
                                1
                                                                5
                                                        4
                                                3
                                        2
                        7

/**/

