#include "tree.h"

// alberi binari

void printH(Tnode_Ptr T, int h)
{
int i;

	if(T)
	{
		printH(T->right,h+1);
			for(i=0;i<h;i++)
				printf("\t");
		printf("%d\n",(int)T->item);
		printH(T->left,h+1);
	}
}


Tnode_Ptr chooseInsert(Tnode_Ptr T, void *elem)
{
int r;

	if(T)
	{
		printf("current item is %d\n[1]->left // [2]->right : ",(int)T->item);
		scanf("%d",&r);
		if(r==1)
		{
			T->left=chooseInsert(T->left,elem);
			return T;
		}
		if(r==2)
		{
			T->right=chooseInsert(T->right,elem);
			return T;
		}
		else
		{
			printf("input error\n");
			exit(1);
		}
	}

	else
	{
		T=malloc(sizeof(Tnode));
		T->left=NULL;	
		T->right=NULL;
		T->item=malloc(sizeof(void*));
		T->item=elem;
		return T;
	}
}

void create_Tree(Tnode_Ptr *T)
{
int ch,elem;

	printf("\n1) inserisce un nuovo elemento\n0) esce\n");
	scanf("%d",&ch);
	
	while(ch)
	{
		printf("che elemento si vuole inserire? : ");
		scanf("%d",&elem);
		*T=chooseInsert(*T,(void*)elem);
		printf("\n\nl'albero corrente e'\n");
		printH(*T,0);
		printf("\n1) inserisce un nuovo elemento\n0) esce\n");
		scanf("%d",&ch);
	}
}

void levelVisit(Tnode_Ptr T)
{
codaVoid_Ptr C;
void *popped;
Tnode_Ptr H;

	if(!T)
		return;

	create_queueVoid(&C);
	C=enqueueVoid(C,T);

	while((popped=dequeueVoid(&C)))
	{
		H=popped;
		printf("sto visitando %d\n",(int)(H->item));
		C=enqueueVoid(C,H->left);
		C=enqueueVoid(C,H->right);
	}

	return;
}

// ALBERI BINARI BILANCIATI

int max(int a, int b)
{
	if(a>b)
		return a;
	else
		return b;
}

void left_rotate(Tnode_Ptr *T, Tnode_Ptr *P)
{
Tnode_Ptr temp;

	if(!(*T)->right) // se non c'e' figlio destro non c'e' niente da fare
		return;
	
	temp=(*T)->right; 
	(*T)->right=(*T)->right->left;
	temp->left=*T;
	*T=temp;

	if(P) {
		// verifico se il nodo T era figlio sinistro o destro di P
		if((*P)->left->item==(*T)->item)
			(*P)->left=*T; 
	
		else
			(*P)->right=*T;
	}
}

void right_rotate(Tnode_Ptr *T, Tnode_Ptr *P)
{
Tnode_Ptr temp;

	if(!(*T)->right) // se non c'e' figlio destro non c'e' niente da fare
		return;
	
	temp=(*T)->left; 
	(*T)->left=(*T)->left->right;
	temp->right=*T;
	*T=temp;

	if(P) {
		// verifico se il nodo T era figlio sinistro o destro di P
		if((*P)->left->item==(*T)->item)
			(*P)->left=*T; 
	
		else
			(*P)->right=*T;
	}
}

void left_left(Tnode_Ptr *T, Tnode_Ptr *P)
{
Tnode_Ptr temp;

	if(!(*T) || !(*T)->left)
		return;

	temp=(*T)->left;
	(*T)->left=(*T)->left->right;
	temp->right=*T;
	*T=temp;

	if(P) {
		if((*P)->left && (*P)->left->item==(*T)->item)
			(*P)->left=*T; 
	
		else
			(*P)->right=*T;
	}

	(*T)->right->hsx=(*T)->hdx; 
	(*T)->hdx=1+max((*T)->hdx,(*T)->right->hdx);
}

void left_right(Tnode_Ptr *T, Tnode_Ptr *P)
{
Tnode_Ptr temp;

	if(!(*T) || !(*T)->left || !(*T)->left->right)
		return;

	temp=(*T)->left;
	(*T)->left=(*T)->left->right;
	temp->right=(*T)->left->left;
	
	(*T)->left->left->hdx=(*T)->left->hsx;
	(*T)->left->hsx=1+max((*T)->left->left->hdx,(*T)->left->left->hsx);
	
	(*T)->left->left=temp;
	
	left_left(T,P);
}

void right_right(Tnode_Ptr *T, Tnode_Ptr *P)
{
Tnode_Ptr temp;

	if(!(*T) || !(*T)->right)
		return;

	temp=(*T)->right;
	(*T)->right=(*T)->right->left;
	temp->left=*T;
	*T=temp;

	if(P) {
		if((*P)->left && (*P)->left->item==(*T)->item)
			(*P)->left=*T; 
	
		else
			(*P)->right=*T;
	}

	(*T)->left->hdx=T->hsx;
	(*T)->hsx=1+max((*T)->hsx,(*T)->left->hsx);
	
}

void right_left(Tnode_Ptr *T, Tnode_Ptr *P)
{
Tnode_Ptr temp;

	if(!(*T) || !(*T)->right || !(*T)->right->left)
		return;

	temp=(*T)->right;
	(*T)->right=(*T)->right->left;
	temp->left=(*T)->right->right;
	(*T)->right->right=temp;
	
	(*T)->right->right->hsx=(*T)->right->hdx;
	(*T)->right->hdx=1+max((*T)->right->right->hsx,(*T)->right->right->hdx);

	right_right(T,P);
}

void print_bil(Tnode_Ptr T, int h)
{
int i;

	if(T)
	{
		print_bil(T->right,h+1);
			for(i=0;i<h;i++)
				printf("\t");
		printf("%d (%d)\n",(int)T->item,T->hsx-T->hdx);
		print_bil(T->left,h+1);
	}
}

int insert_bil(Tnode_Ptr *T, Tnode_Ptr *P, int elem)
{
int ret;

	if(!*T) {
		*T=malloc(sizeof(Tnode));
		(*T)->left=(*T)->right=NULL;
		(*T)->hsx=(*T)->hdx=0;
		(*T)->item=(void*)elem;
		return 0;
	}

	if(elem>(int)(*T)->item) {
		ret=insert_bil(&(*T)->right,T,elem);
		(*T)->hdx=1+ret;
	}	
		
	else {
		ret=insert_bil(&(*T)->left,T,elem);
		(*T)->hsx=1+ret;
	}	
	
	if(((*T)->hsx-(*T)->hdx)>1) {
		if(ret<0)
			left_right(T,P);
		else {
			if(ret>0)
				left_left(T,P);
			else
				printf("!?!?\n");
		}
	}

	if((*T)->degree<-1) {
		if(ret<0)
			right_right(T,P);
		else {
			if(ret>0)
				right_left(T,P);
			else 
				printf("!?!?\n");
		}
	}

	return max((*T)->hsx,(*T)->hdx);
}

void bil_cycle(void)
{
Tnode_Ptr T=NULL;
int elem,ret;

	while(1) {
		printf("\nl'albero corrente e':\n\n");
		print_bil(T,0);

		printf("elemento da inserire: ");
		scanf("%d",&elem);

		ret=insert_bil(&T,NULL,elem);
/*		
		printf("\nl'albero corrente e':\n\n");
		print_bil(T,0);

		if(T->degree>1) {
			if(ret<0)
				left_right(&T,NULL);
			if(ret>0)
				left_left(&T,NULL);
			else 
				printf("!?!?\n");
		}

		if(T->degree<-1) {
			if(ret<0)
				right_right(&T,NULL);
			if(ret>0)
				right_left(&T,NULL);
			else 
				printf("!?!?\n");
		} */ 
	}
}
		
// alberi n_ari
void print_n(n_tree_ptr T, int h) 
{
int i;
	if(T)
	{
		for(i=0;i<h;i++)
			printf("\t");
		printf("%d\n",(int)T->item);
		
		print_n(T->figlio,h+1);

		print_n(T->fratello,h);
	}
}


void create_Tree_n(n_tree_ptr *T)
{
int ch,elem;

	printf("\n1) inserisce un nuovo elemento\n0) esce\n");
	scanf("%d",&ch);
	
	while(ch)
	{
		printf("che elemento si vuole inserire? : ");
		scanf("%d",&elem);
		*T=chooseInsert_n(*T,(void*)elem);
		printf("\n\nl'albero corrente e'\n");
		print_n(*T,0);
		printf("\n1) inserisce un nuovo elemento\n0) esce\n");
		scanf("%d",&ch);
	}
}

n_tree_ptr chooseInsert_n(n_tree_ptr T, void *elem)
{
int r;

	if(T)
	{
		printf("current item is %d\n[1]->fratello // [2]->figlio : ",(int)T->item);
		scanf("%d",&r);
		if(r==1)
		{
			T->fratello=chooseInsert_n(T->fratello,elem);
			return T;
		}
		if(r==2)
		{
			T->figlio=chooseInsert_n(T->figlio,elem);
			return T;
		}
		else
		{
			printf("input error\n");
			exit(1);
		}
	}

	else
	{
		T=malloc(sizeof(n_tree));
		T->figlio=NULL;	
		T->fratello=NULL;
		T->item=malloc(sizeof(void*));
		T->item=elem;
		return T;
	}
}

// da n_ari a bin e viceversa

// da n_ari a bin..
Tnode_Ptr n_to_bin(n_tree_ptr N, Tnode_Ptr B)
{
	assert(!B);

	if(!N)
		return NULL;

	B=malloc(sizeof(Tnode));
	B->item=N->item;
	B->left=n_to_bin(N->figlio,B->left);
	B->right=n_to_bin(N->fratello,B->right);

	return B;
}

// da bin a n_ari..
n_tree_ptr bin_to_n(Tnode_Ptr B, n_tree_ptr N)
{
	assert(!N);

	if(!B)
		return NULL;
	
	N=malloc(sizeof(n_tree));
	N->item=B->item;
	N->fratello=bin_to_n(B->right,N->fratello);
	N->figlio=bin_to_n(B->left,N->figlio);

	return N;
}


/* HEAP */

// dovrei fare una cosa bella tipo puntatori a funzione ma non mi va


int* tree_to_vet(Tnode_Ptr T, int n_elem)
{
int *vett,i=1;
codaVoid_Ptr Q=NULL;
Tnode_Ptr H;

	create_queueVoid(&Q);

	vett=calloc(n_elem+1,sizeof(int));

	Q=enqueueVoid(Q,(void*)T);
	
	while((H=(Tnode_Ptr)dequeueVoid(&Q)))
	{
		vett[i]=(int)H->item;
		if(H->left)
		{
			vett[(2*i)]=(int)H->left->item;
			Q=enqueueVoid(Q,(void*)H->left);
		}
	
		if(H->right)
		{
			vett[((2*i)+1)]=(int)H->right->item;
			Q=enqueueVoid(Q,(void*)H->right);
		}

		free(H);

		i++;
	}

	return vett;
}

Tnode_Ptr heap_to_tree(int *heap, int in, int fin)
{
Tnode_Ptr T;

	T=malloc(sizeof(Tnode));
	
	T->item=(void*)heap[in];
	T->left=NULL;
	T->right=NULL;
	
	if((in*2<=fin))
		T->left=heap_to_tree(heap,(in*2),fin);
	if(((in*2)+1<=fin))
		T->right=heap_to_tree(heap,((in*2)+1),fin);

	return T;

}
	
// HEAP MASSIMO

void heapify(int *heap, int in, int fin)
{
int temp,j,i=in;

	while((2*i)<fin)
	{
		if(heap[(2*i)]>heap[((2*i)+1)]) // scelgo il maggiore tra i figli
			j=2*i;
		else
			j=(2*i)+1;
			
		if(heap[i]<heap[j]) // se la radice e' minore la scambio e riparto dalla radice spostata
		{
			temp=heap[i];
			heap[i]=heap[j];
			heap[j]=temp;

			i=j;
		}

		else		// altrimenti la radice e' al posto giusto quindi esco
			break;
	}

	if(2*i==fin) // se sono uscito perche' 2*i e' uguale a fin, faccio un controllo su quest'ultimo elemento prima di uscire
	{
		if(heap[i]<heap[2*i])
		{
			temp=heap[i];
			heap[i]=heap[2*i];
			heap[2*i]=temp;
		}
	}

	return;
}
	

void HeapSort(int *heap, int in, int fin)
{
int temp,i;

	for(i=fin;i-1>=2;i--)
	{
		temp=heap[i];
		heap[i]=heap[1];
		heap[1]=temp;
		
		heapify(heap,1,i-1);
	}
}

void make_heap(int *heap, int fin)
{
int i;

	for(i=(fin/2);i>=1;i--)
		heapify(heap,i,fin);
}

void elimina_da_heap(int *heap, int fin, int elem)
{
int i,temp;

	for(i=1;i<=fin;i++) // cerco l'elemento
		if(heap[i]==elem)
			break;

	if(i==fin+1) 
		return; // se sto qui vuol dire che non ho trovato l'elemento
			// che cercavo, quindi esco

	heap[i]=heap[fin]; // ora scambio l'elemento che voglio eliminare con l'ultima foglia
	heap[fin]=0; // mettendo a "0" un valore del vettore considero quel nodo cancellato

	heapify(heap,i,fin-1); // ora sistemo l'heap verso il basso
	// ora lo sistemo verso l'alto
	while((i/2) && (heap[i/2]<heap[i])) {
		temp=heap[i];
		heap[i]=heap[i/2];
		heap[i/2]=temp;
		i=i/2;
	}	
}


// HEAP MINIMO

void heapify_min(int *heap, int in, int fin)
{
int temp,j,i=in;

	while((2*i)<fin)
	{
		if(heap[(2*i)]<heap[((2*i)+1)]) // scelgo il minore tra i figli
			j=2*i;
		else
			j=(2*i)+1;
			
		if(heap[i]>heap[j]) // se la radice e' maggiore la scambio e riparto dalla radice spostata
		{
			temp=heap[i];
			heap[i]=heap[j];
			heap[j]=temp;

			i=j;
		}

		else		// altrimenti la radice e' al posto giusto quindi esco
			break;
	}

	if(2*i==fin) // se sono uscito perche' 2*i e' uguale a fin, faccio un controllo su quest'ultimo elemento prima di uscire
	{
		if(heap[i]>heap[2*i])
		{
			temp=heap[i];
			heap[i]=heap[2*i];
			heap[2*i]=temp;
		}
	}

	return;
}
	

void HeapSort_min(int *heap, int in, int fin)
{
int temp,i;

	for(i=fin;i-1>=2;i--)
	{
		temp=heap[i];
		heap[i]=heap[1];
		heap[1]=temp;
		
		heapify_min(heap,1,i-1);
	}
}

void make_heap_min(int *heap, int fin)
{
int i;

	for(i=(fin/2);i>=1;i--)
		heapify_min(heap,i,fin);
}

void elimina_da_heap_min(int *heap, int fin, int elem)
{
int i,temp;

	for(i=1;i<=fin;i++) // cerco l'elemento
		if(heap[i]==elem)
			break;

	if(i==fin+1) 
		return; // se sto qui vuol dire che non ho trovato l'elemento
			// che cercavo, quindi esco

	heap[i]=heap[fin]; // ora scambio l'elemento che voglio eliminare con l'ultima foglia
	heap[fin]=0; // mettendo a "0" un valore del vettore considero quel nodo cancellato

	heapify_min(heap,i,fin-1); // ora sistemo l'heap verso il basso
	
	// ora lo sistemo verso l'alto
	while((i/2) && (heap[i/2]>heap[i])) {
		temp=heap[i];
		heap[i]=heap[i/2];
		heap[i/2]=temp;
		i=i/2;
	}	
		
		
}

// da lista di adiacenza che rappresenta un albero n-ario a un albero n-ario
n_tree_ptr ad_to_n(list_Ptr *G, n_tree_ptr T, int elem, list_Ptr L)
{
	T=malloc(sizeof(n_tree));
	T->item=(int*)elem;
	T->figlio=NULL;
	T->fratello=NULL;

	if(G[elem])
		T->figlio=ad_to_n(G,T->figlio,G[elem]->val,G[elem]->next);
	if(L)
		T->fratello=ad_to_n(G,T->fratello,L->val,L->next);

	return T;
}

// da lista di adiacenza che rappresenta un albero n-ario a un albero binario

Tnode_Ptr ad_to_bin(list_Ptr *G, Tnode_Ptr T, int elem, list_Ptr L)
{
	T=malloc(sizeof(Tnode));
	T->item=(int*)elem;
	T->left=NULL;
	T->right=NULL;

	if(G[elem])
		T->left=ad_to_bin(G,T->left,G[elem]->val,G[elem]->next);
	if(L)
		T->right=ad_to_bin(G,T->right,L->val,L->next);

	return T;
}

